package System::BART;

use PerlLib::Util;

use Data::Dumper;
use IO::File;
use File::Temp qw(tempfile tempdir);

use Class::MethodMaker
  new_with_init => 'new',
  get_set       =>
  [

   qw / MyProcessString  /

  ];

sub init {
  my ($self,%args) = @_;
  $self->MyProcessString("java -Xmx1024m elkfed.webdemo.BARTServer");
}

sub StartServer {
  my ($self,%args) = @_;
  # check that it is not already running
  # put in expect to know when the server is actually ready
  if (! $self->AlreadyRunning) {
    my $c = "cd /var/lib/myfrdcsa/sandbox/bart-20091005/bart-20091005/BART-snapshot/BART && source setup.sh && java -Xmx1024m elkfed.webdemo.BARTServer &";
    print "$c\n";
    system $c;
    print "Sleeping 30\n";
    sleep 30;
  }
}

sub AlreadyRunning {
  my ($self,%args) = @_;
  my $item = PidsForProcess
    (Process => $self->MyProcessString);
  return scalar @$item;
}

sub StopServer {
  my ($self,%args) = @_;
  KillProcesses
    (Process => $self->MyProcessString);
}

sub CoreferenceResolution {
  my ($self,%args) = @_;
  my $tf = File::Temp->new;
  my $fn = $tf->filename;
  my $fh = IO::File->new
    (">$fn");
  $fh->print($args{Text});
  my $result = `cat $fn | POST http://localhost:8125/BARTDemo/ShowText/process/`;
  $fh->close;
  return $result;
}

1;
